# ---------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ---------------------------------------------------------------------------
apiVersion: camel.apache.org/v1alpha1
kind: Kamelet
metadata:
  name: ftps-source
  annotations:
    camel.apache.org/kamelet.support.level: "Stable"
    camel.apache.org/catalog.version: "3.21.0"
    camel.apache.org/kamelet.icon: "data:image/svg+xml;base64,[encoded data, 7188 characters]"
    camel.apache.org/provider: "Apache Software Foundation"
    camel.apache.org/kamelet.group: "FTP"
    camel.apache.org/kamelet.namespace: "File"
  labels:
    camel.apache.org/kamelet.type: "source"
spec:
  definition:
    title: "FTPS Source"
    description: |-
      Receive data from an FTPS server.
    required:
      - connectionHost
      - connectionPort
      - username
      - password
      - directoryName
    type: object
    properties:
      connectionHost:
        title: Connection Host
        description: The hostname of the FTPS server.
        type: string
      connectionPort:
        title: Connection Port
        description: The port of the FTPS server.
        type: string
        default: 21
      username:
        title: Username
        description: The username to access the FTPS server.
        type: string
        x-descriptors:
        - urn:camel:group:credentials
      password:
        title: Password
        description: The password to access the FTPS server.
        type: string
        format: password
        x-descriptors:
        - urn:alm:descriptor:com.tectonic.ui:password
        - urn:camel:group:credentials
      directoryName:
        title: Directory Name
        description: The starting directory.
        type: string
      passiveMode:
        title: Passive Mode
        description: Specifies to use passive mode connection.
        type: boolean
        default: false
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
      recursive:
        title: Recursive
        description: If a directory, look for files in all sub-directories as well.
        type: boolean
        default: false
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
      idempotent:
        title: Idempotency
        description: Skip already-processed files.
        type: boolean
        default: true
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
      binary:
        title: Binary
        description: Specifies the file transfer mode, BINARY or ASCII. Default is ASCII (false).
        type: boolean
        default: false
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
      autoCreate:
        title: Autocreate Missing Directories
        description: Automatically create starting directory.
        type: boolean
        default: true
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
      delete:
        title: Delete
        description: If true, the file will be deleted after it is processed successfully.
        type: boolean
        default: false
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
  dependencies:
    - "camel:ftp"
    - "camel:core"
    - "camel:kamelet"
  template:
    from:
      uri: "ftps:{{username}}@{{connectionHost}}:{{connectionPort}}/{{directoryName}}"
      parameters:
        password: "{{password}}"
        passiveMode: "{{passiveMode}}"
        recursive: "{{recursive}}"
        idempotent: "{{idempotent}}"
        binary: "{{binary}}"
        autoCreate: "{{autoCreate}}"
        delete: "{{delete}}"
      steps:
      - set-header:
          name: file
          simple: "${header[CamelFileName]}"
      - set-header:
          name: ce-file
          simple: "${header[CamelFileName]}"
      - convert-body-to:
          type: "java.io.InputStream"
      - to: "kamelet:sink"